<?php
/*
 * Copyright (C) 2017 Puiu Calin
 * This program is a commercial software: is forbidden to use this software without licence, 
 * on multiple installations, and by purchasing from other source than those authorized for the sale of software.
 * Unauthorized copying of this file, via any medium is strictly prohibited
 */

if ((!defined('ABS_PATH')))
    exit('ABS_PATH is not loaded. Direct access is not allowed.');

if (!OC_ADMIN)
    exit('User access is not allowed.');
$maxPHPsize = cbk_avatar_get_max_size_server();
?>
<script type="text/javascript">
    $(document).ready(function () {
        $('.cbk_admin_menu div').click(function () {
            $('.cbk_admin_menu div').removeClass('active');
            $(this).addClass('active');
            var curent_class = $(this).attr('data-class');
            $('.div_show').slideUp();
            $('#' + curent_class).show();
        });
        $('.cbk_welcome .welcome_close').click(function () {
            $('.cbk_welcome').hide();
        });
    });
</script>
<div class="cbk_admin_menu">
    <div data-class="s_help" class="">
        <img title="<?php _e('Help', 'cbk_avatar'); ?>" src="<?php echo osc_base_url() . 'oc-content/plugins/cbk_avatar/images/help.png'; ?>" />
    </div>
    <div data-class="s_settings" class="active">
        <img title="<?php _e('Settings', 'cbk_avatar'); ?>" src="<?php echo osc_base_url() . 'oc-content/plugins/cbk_avatar/images/settings-hover.png'; ?>" />
    </div>
</div>
<?php if (osc_get_preference('admin_welcome', 'cbk_avatar') != '1') { ?>
    <div class="cbk_welcome">
        <div class="welcome_close">x</div>
        <h4><?php _e('Welcome to CbK Avatar settings, this is your first visit in the plugin settings, here are some few things that can help you.', 'cbk_avatar'); ?></h4>
        <?php _e('This plugin allow your users to set an avatar image, and you as administrator to use this information in your theme by displaying a image from those 3 dimensions.', 'cbk_avatar'); ?>
        <br/>
        <?php _e('In the right top corner you have 2 buttons, one will get you on settings page and one on help page where you will find the documentation for this plugin and some steps for installing this plugin.', 'cbk_avatar'); ?>
        <br />
        <?php _e('The plugin will create an column in your user table and in that column you will have the user avatar.', 'cbk_avatar'); ?>
        <br/>
        <?php _e('Enjoy this plugin, and give us a feedback!', 'cbk_avatar'); ?>
    </div>
<?php } ?>
<div id="s_settings" class="div_show active">
    <form action="<?php echo osc_admin_render_plugin_url('cbk_avatar/admin/settings.php'); ?>" method="post" enctype="multipart/form-data">  
        <input type="hidden" name="cbk_avatar_action_specific" value="cbk_avatar_settings" />
        <fieldset>
            <?php include_once'user_stats.php'; ?>
            <div class="form-horizontal">
                <h3><?php _e('Image sizes', 'cbk_avatar'); ?></h3>
                <p>	<?php _e('The sizes listed below determine the maximum dimensions in pixels to use when uploading a image. Format: Width x Height.', 'cbk_avatar'); ?></p>
                <div class="form-row">
                    <div class="form-label"><?php _e('Maximum size', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <input name="max_size" value="<?php echo osc_esc_html(osc_get_preference('max_size', 'cbk_avatar')); ?>" />
                        <span class="help-box"><?php _e('Size in KB'); ?></span>
                        <div class="flashmessage flashmessage-warning flashmessage-inline">
                            <p><?php printf(__('Maximum size PHP configuration allows: %d KB'), $maxPHPsize); ?></p>
                        </div>
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-label"><?php _e('Small dimension', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <input name="small_dimension" value="<?php echo osc_esc_html(osc_get_preference('small_dimension', 'cbk_avatar')); ?>" />
                        <p>	<?php _e('This image has to be set, this will be used by default or in some cases when the other sizes of avatar will not be available.', 'eighteen'); ?></p>
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-label"><?php _e('Store other dimensions', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <select name="other_dimensions" id="other_dimensions">
                            <option value="1" <?php
                            if (osc_get_preference('other_dimensions', 'cbk_avatar') !== '0') {
                                echo 'selected="selected"';
                            }
                            ?>><?php _e('Yes', 'cbk_avatar'); ?></option> 
                            <option value="0"<?php
                            if (osc_get_preference('other_dimensions', 'cbk_avatar') !== '1') {
                                echo 'selected="selected"';
                            }
                            ?>><?php _e('No', 'cbk_avatar'); ?></option>
                        </select>
                        <div class="help-box"><?php _e('You can come to store or not other dimensions of the avatar on your site, this is helpful if you intend to use more large images of user avatar in different part of your site.', 'cbk_avatar'); ?></div>		
                    </div>		
                </div>
                <div class="form-row">
                    <div class="form-label"><?php _e('Thumbnail size', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <input name="thumb_dimension" value="<?php echo osc_esc_html(osc_get_preference('thumb_dimension', 'cbk_avatar')); ?>" />
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-label"><?php _e('Normal size', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <input name="normal_dimension" value="<?php echo osc_esc_html(osc_get_preference('normal_dimension', 'cbk_avatar')); ?>" />
                    </div>
                </div>
            </div>
            <div class="form-horizontal">
                <h3><?php _e('Default avatar', 'cbk_avatar'); ?></h3>
                <div class="form-row">
                    <div class="form-label"><?php _e('Current image', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <img class="admin_default_image_cbk_avatar" src="<?php echo cbk_avatar_no_image_link(); ?>" />
                        <?php if (osc_get_preference('no_image_extension', 'cbk_avatar') != '') { ?>
                            <a href="<?php echo osc_admin_render_plugin_url('cbk_avatar/admin/settings.php?cbk_avatar_action_specific=delete_default_avatar'); ?>"><?php _e('Delete default avatar', 'cbk_avatar'); ?></a>
                        <?php } ?>
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-label"><?php _e('Change default avatar', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <input type="file" name="cbk_new_avatar" value="" /><?php _e('only', 'cbk_avatar'); ?>: <strong><?php echo cbk_images_extensions_list(); ?></strong>
                    </div>
                </div>
            </div>
            <div class="form-horizontal">   
                <h3><?php _e('Auto embed the lines for edit and register user form, if the proper hooks exist in your theme', 'cbk_avatar'); ?></h3>
                <div class="form-row">
                    <div class="form-label"><?php _e('Auto embed', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <select name="auto_embed" id="auto_embed">
                            <option value="1" <?php
                            if (osc_get_preference('auto_embed', 'cbk_avatar') !== '0') {
                                echo 'selected="selected"';
                            }
                            ?>><?php _e('Yes', 'cbk_avatar'); ?></option> 
                            <option value="0"<?php
                            if (osc_get_preference('auto_embed', 'cbk_avatar') !== '1') {
                                echo 'selected="selected"';
                            }
                            ?>><?php _e('No', 'cbk_avatar'); ?></option>
                        </select>
                        <div class="help-box"><?php _e('If the proper hooks exist in your theme you can choose to auto embed the lines, this means that the line will be displayed without editing the files of your theme. But take notest that it posible that the style or the structure of this fields will not match with your theme and some aditional style need to be added. You can use field custom style to add this style.', 'cbk_avatar'); ?></div>		
                        <div class="help-box"><?php _e('For auto embedding to work your theme has to have in edit user file user_profile_form hook and in register file user_register_form hook.', 'cbk_avatar'); ?></div>
                    </div>		
                </div>
            </div>
            <div class="form-horizontal">   
                <h3><?php _e('Custom style', 'cbk_avatar'); ?></h3>
                <div class="form-row">
                    <div class="form-label"><?php _e('Custom style', 'cbk_avatar'); ?></div>
                    <div class="form-controls">
                        <textarea style="height: 115px; width: 500px;"name="custom_style"><?php echo osc_esc_html(osc_get_preference('custom_style', 'cbk_avatar')); ?></textarea>
                        <br/><br/>
                        <div class="help-box"><?php _e('You can set a custom style by including the class in this field and the style for that class or id.', 'cbk_avatar'); ?></div>
                    </div>
                </div>
            </div>
            <div class="form-actions cbk_save">
                <input type="submit" value="<?php _e('Save changes', 'cbk_avatar'); ?>" class="btn btn-submit" />
            </div>
        </fieldset>
    </form>
</div>
<div id="s_help" class="div_show">
    <?php include_once'help.php'; ?>
</div>
<div class="cbk_author">
    <?php cbk_avatar_autor_rights(); ?>
</div>
<?php
//set first visit admin
osc_set_preference('admin_welcome', '1', 'cbk_avatar');
switch (Params::getParam('cbk_avatar_action_specific')) {
    case('cbk_avatar_settings'):
        $max_size = Params::getParam('max_size');
        if ($max_size <= $maxPHPsize) {
            osc_set_preference('max_size', $max_size, 'cbk_avatar');
            osc_set_preference('small_dimension', Params::getParam('small_dimension'), 'cbk_avatar');
            osc_set_preference('other_dimensions', Params::getParam('other_dimensions'), 'cbk_avatar');
            osc_set_preference('thumb_dimension', Params::getParam('thumb_dimension'), 'cbk_avatar');
            osc_set_preference('normal_dimension', Params::getParam('normal_dimension'), 'cbk_avatar');
            osc_set_preference('auto_embed', Params::getParam('auto_embed'), 'cbk_avatar');
            osc_set_preference('custom_style', trim(Params::getParam('custom_style', false, false, false)), 'cbk_avatar');
            //upload the default image
            $file = Params::getFiles('cbk_new_avatar');
            $file_name = $file['name'];
            $file_tmp = $file['tmp_name'];
            $file_size = $file['size'];
            $file_error = $file['error'];
            $file_ext = explode('.', $file_name);
            $file_ext = strtolower(end($file_ext));
            $allowed = cbk_images_exensions();
            $max_filesize = cbk_avatar_size();
            if (!empty($file_size)) {
                if (in_array($file_ext, $allowed)) {
                    if ($file_size > $max_filesize) {
                        $message = __('Avatar image size to big, max image size', 'cbk_avatar') . '&nbsp;' . cbk_avatar_formatSize($max_filesize);
                        osc_add_flash_error_message($message, 'admin');
                    } else {
                        //save image
                        CbK_Avatar::newInstance()->admin_upload_no_image($file_tmp, $file_ext);
                    }
                } else {
                    $ext_show = implode(', ', $allowed);
                    $message = __('Image extension not allowed, only extensions', 'cbk_avatar') . '&nbsp;' . $ext_show;
                    osc_add_flash_error_message($message, 'admin');
                }
            }
        } else {
            osc_add_flash_error_message(__('The maximum size exceeded the maximum allowed by server', 'cbk_avatar'), 'admin');
        }
        osc_add_flash_ok_message(__('Plugin settings updated correctly', 'cbk_avatar'), 'admin');
        header("Location:" . osc_admin_render_plugin_url('cbk_avatar/admin/settings.php'));
        break;
    case('delete_default_avatar'):
        $curent_image_extension = osc_get_preference('no_image_extension', 'cbk_avatar');
        if (!empty($curent_image_extension)) {
            //first delete the curent images
            $folder = osc_plugin_path('cbk_avatar/images/');
            if (@unlink($folder . 'no_image_normal.' . $curent_image_extension) && @unlink($folder . 'no_image_thumbnail.' . $curent_image_extension) && @unlink($folder . 'no_image.' . $curent_image_extension)) {
                osc_set_preference('no_image_extension', '', 'cbk_avatar');
                osc_add_flash_ok_message(__('The default avatar was deleted', 'cbk_avatar'), 'admin');
            } else {
                osc_add_flash_error_message(__('The default avatar was not deleted', 'cbk_avatar'), 'admin');
            }
        }
        header("Location:" . osc_admin_render_plugin_url('cbk_avatar/admin/settings.php'));
        break;
}