<?php
/*
 * Copyright (C) 2017 Puiu Calin
 * This program is a commercial software: is forbidden to use this software without licence, 
 * on multiple installations, and by purchasing from other source than those authorized for the sale of software.
 * Unauthorized copying of this file, via any medium is strictly prohibited
 */

if ((!defined('ABS_PATH')))
    exit('ABS_PATH is not loaded. Direct access is not allowed.');

if (!OC_ADMIN)
    exit('User access is not allowed.');
$users_width_image = CbK_Avatar::newInstance()->count_all_records();
$total_users = osc_total_users('b_active');
//total stats
$total_register = CbK_Avatar::newInstance()->count_registered_users();
$total_inactive = $total_register - $total_users;
$blocked = User::newInstance()->countUsers('b_enabled = 0');
$options = 0;
?>
<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<script type="text/javascript">

    // Load the Visualization API and the corechart package.
    google.charts.load('current', {'packages': ['corechart']});

    // Set a callback to run when the Google Visualization API is loaded.
    google.charts.setOnLoadCallback(drawChart);

    // Callback that creates and populates a data table,
    // instantiates the pie chart, passes in the data and
    // draws it.
    function drawChart() {

        // Create the data table.
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Topping');
        data.addColumn('number', 'Slices');
        data.addRows([
            ['<?php echo osc_esc_js(__('Without avatar')); ?>', <?php echo $total_users; ?>],
            ['<?php echo osc_esc_js(__('With avatar')); ?>', <?php echo $users_width_image; ?>]
        ]);

        // Set chart options
        var options = {
            'width': '100%',
            'height': 200,
            colors: ['#DC3912', '#3366CC']
        };

        // Instantiate and draw our chart, passing in some options.
        var chart = new google.visualization.PieChart(document.getElementById('users_with_avatar'));
        chart.draw(data, options);
        var chart = new google.charts.Bar(document.getElementById('top_x_div'));
        chart.draw(data, options);
    }
    //widget 2
    google.charts.load('current', {packages: ['corechart', 'bar']});
    google.charts.setOnLoadCallback(drawBasic);

    function drawBasic() {

        var data = google.visualization.arrayToDataTable([
            ['<?php echo osc_esc_js(__('Display by')); ?>', '<?php echo $total_register . osc_esc_js(__(' Users')); ?>', {role: 'annotation'}],
            ['<?php echo osc_esc_js(__('Total')); ?>', <?php echo $total_register; ?>, <?php echo $total_register; ?>],
            ['<?php echo osc_esc_js(__('Active')); ?>', <?php echo $total_users; ?>, <?php echo $total_users; ?>],
            ['<?php echo osc_esc_js(__('Inactive')); ?>', <?php echo $total_inactive; ?>, <?php echo $total_inactive; ?>],
            ['<?php echo osc_esc_js(__('With avatar')); ?>', <?php echo $users_width_image; ?>, <?php echo $users_width_image; ?>],
            ['<?php echo osc_esc_js(__('Blocked')); ?>', <?php echo $users_width_image; ?>, <?php echo $users_width_image; ?>]

        ]);

        var options = {
            chartArea: {width: '50%'},
            hAxis: {
                minValue: 0,
            },
            vAxis: {
                title: '<?php echo osc_esc_js(__('Display by')); ?>'
            }
        };

        var chart = new google.visualization.BarChart(document.getElementById('total_stats'));
        chart.draw(data, options);
    }
</script>   
<div class="form-horizontal stats_cbk">
    <h3><?php _e('Stats', 'cbk_avatar'); ?></h3>
    <div class="cbk_half">
        <div class="stats_title"><?php _e('How many active users use this plugin to set an avatar on profile', 'cbk_avatar'); ?></div>
        <div id="users_with_avatar">
        </div>
    </div>
    <div class="cbk_half last">
        <div class="stats_title"><?php _e('Users stats', 'cbk_avatar'); ?></div>
        <div id="total_stats">
        </div>
    </div>
    <?php if ($options) { ?>
        <?php
        $dir = osc_base_path() . 'oc-content/plugins/cbk_avatar/users/';
        $size = cbk_avatar_folderSize($dir);
        ?>
        <div class="file-size">
            <?php _e('User images folder size', 'cbk_avatar'); ?>: <strong><?php echo cbk_avatar_formatSize($size); ?></strong>
        </div>
    <?php } ?>
</div>