<?php
/*
 * Copyright (C) 2017 Puiu Calin
 * This program is a commercial software: is forbidden to use this software without licence, 
 * on multiple installations, and by purchasing from other source than those authorized for the sale of software.
 * Unauthorized copying of this file, via any medium is strictly prohibited
 */

/*
 * input filed for upload image
 */

function cbk_avatar_input_field() {
    ?>
    <input type="file" name="cbk_avatar" id="cbk_avatar"/>
    <?php
}

/*
 * add enctype to form
 */

function cbk_avatar_add_enctype() {
    ?>
    <script type="text/javascript">
        $(document).ready(function () {
            //add enctype
            $("form").attr("enctype", "multipart/form-data");
        });
    </script>
    <?php
}

/*
 * only the upload field
 */

function cbk_avatar_form_field() {
    cbk_avatar_input_field();
    cbk_avatar_add_enctype();
}

/*
 * include the upload button, bender base
 * include thsi line in theme
 */

function cbk_avatar_include_form($custom_class = NULL) {
    if (is_array($custom_class)) {
        $custom_class = '';
    }
    if (osc_is_register_page()) {
        //the input field from register page
        ?>
        <div class="control-group <?php echo $custom_class; ?>">
            <label class="control-label"><?php _e('Set avatar', 'cbk_avatar'); ?></label>
            <div class="controls">
                <?php cbk_avatar_input_field(); ?>
                <br />
                <?php _e('only', 'cbk_avatar'); ?>: <strong><?php echo cbk_images_extensions_list(); ?></strong>
            </div>
        </div>
        <style type="text/css">
            #cbk_avatar{border-color:transparent;box-shadow: initial;padding:0px;}
        </style>
        <?php
    } elseif (osc_is_user_profile()) {
        //input filed from user edit
        $user_id = osc_user_id();
        cbk_avatar_deleteBy_user_id($user_id);
        ?>
        <div class="cbk_avatar_user <?php echo $custom_class; ?>">
            <?php if (cbk_avatar_is_set($user_id)) { ?>
                <div class="control-group">
                    <label><?php _e('Current avatar', 'cbk_avatar'); ?></label>
                    <div class="controls">
                        <div class="cbk_delete">
                            <img src="<?php echo cbk_avatar_thumbnail_link(); ?>" />
                            <a href="<?php echo cbk_avatar_user_delete_avatar_link(); ?>">
                                <?php _e('Delete', 'cbk_avatar'); ?> 
                            </a>
                        </div>
                    </div>
                </div>
                <div class="control-group">
                    <label><?php _e('Change avatar', 'cbk_avatar'); ?></label>
                    <div class="controls">
                        <?php cbk_avatar_input_field(); ?>
                        <?php _e('only', 'cbk_avatar'); ?>: <strong><?php echo cbk_images_extensions_list(); ?></strong>
                    </div>
                </div>
            <?php } else { ?>
                <div class="control-group">
                    <label><?php _e('Current avatar', 'cbk_avatar'); ?></label>
                    <div class="controls">
                        <img src="<?php echo cbk_avatar_no_image_link(); ?>" />
                    </div>
                </div>
                <div class="control-group">
                    <label><?php _e('Set avatar', 'cbk_avatar'); ?></label>
                    <div class="controls">
                        <?php cbk_avatar_input_field(); ?>
                        <br />
                        <?php _e('only', 'cbk_avatar'); ?>: <strong><?php echo cbk_images_extensions_list(); ?></strong>
                    </div>
                </div>
            <?php } ?>
        </div>
        <style type="text/css">
            #cbk_avatar{border-color:transparent;box-shadow: initial;padding:0px;}
        </style>
        <?php
    }
    cbk_avatar_add_enctype();
}

/*
 * check image data before register
 */

function cbk_avatar_image_check() {
    $file = Params::getFiles('cbk_avatar');
    $file_name = $file['name'];
    $file_tmp = $file['tmp_name'];
    $file_size = $file['size'];
    $file_error = $file['error'];
    $file_ext = explode('.', $file_name);
    $file_ext = strtolower(end($file_ext));
    $allowed = cbk_images_exensions();
    $max_filesize = cbk_avatar_size();
    if (!empty($file_size)) {
        if (in_array($file_ext, $allowed)) {
            if ($file_size > $max_filesize) {
                $message = __('Avatar image size to big, max image size', 'cbk_avatar') . '&nbsp;' . cbk_avatar_formatSize($max_filesize);
                osc_add_flash_error_message($message);
                osc_redirect_to(osc_register_account_url());
            }
        } else {
            $ext_show = implode(', ', $allowed);
            $message = __('Image extension not allowed, only extensions', 'cbk_avatar') . '&nbsp;' . $ext_show;
            osc_add_flash_error_message($message);
            osc_redirect_to(osc_register_account_url());
        }
    } else {
        //only if the image is mandatory
    }
}

osc_add_hook('before_user_register', 'cbk_avatar_image_check');

/*
 * check image data on edit
 */

function cbk_avatar_image_check_edit() {
    $file = Params::getFiles('cbk_avatar');
    $file_name = $file['name'];
    $file_tmp = $file['tmp_name'];
    $file_size = $file['size'];
    $file_error = $file['error'];
    $file_ext = explode('.', $file_name);
    $file_ext = strtolower(end($file_ext));
    $allowed = cbk_images_exensions();
    $max_filesize = cbk_avatar_size();
    if (!empty($file_size)) {
        if (in_array($file_ext, $allowed)) {
            if ($file_size > $max_filesize) {
                $message = __('Avatar image size to big, max image size', 'cbk_avatar') . '&nbsp;' . cbk_avatar_formatSize($max_filesize);
                if (OC_ADMIN) {
                    $user_id = Params::getParam('id');
                    osc_add_flash_error_message($message, 'admin');
                    osc_redirect_to(osc_admin_base_url(true) . '?page=users&action=edit&id=' . $user_id);
                } else {
                    //user dashboard
                    osc_add_flash_error_message($message);
                    osc_redirect_to(osc_user_profile_url());
                }
            }
        } else {
            $ext_show = implode(', ', $allowed);
            $message = __('Image extension not allowed, only extensions', 'cbk_avatar') . '&nbsp;' . $ext_show;
            if (OC_ADMIN) {
                $user_id = Params::getParam('id');
                osc_add_flash_error_message($message, 'admin');
                osc_redirect_to(osc_admin_base_url(true) . '?page=users&action=edit&id=' . $user_id);
            } else {
                //user dashboard
                osc_add_flash_error_message($message);
                osc_redirect_to(osc_user_profile_url());
            }
        }
    } else {
        //only if the image is mandatory
    }
}

osc_add_hook('pre_user_post', 'cbk_avatar_image_check_edit');

/*
 * set image for user
 */

function cbk_avatar_set_image($user_id) {
    $file = Params::getFiles('cbk_avatar');
    $file_name = $file['name'];
    $file_tmp = $file['tmp_name'];
    $file_size = $file['size'];
    $file_error = $file['error'];
    $file_ext = explode('.', $file_name);
    $file_ext = strtolower(end($file_ext));
    if (!empty($file_size)) {
        CbK_Avatar::newInstance()->save_image_data($user_id, $file_ext, $file_tmp);
    }
}

osc_add_hook('user_register_completed', 'cbk_avatar_set_image');
/*
 * edit image of user
 */

function cbk_avatar_edit_image($user_id) {
    $file = Params::getFiles('cbk_avatar');
    $file_name = $file['name'];
    $file_tmp = $file['tmp_name'];
    $file_size = $file['size'];
    $file_error = $file['error'];
    $file_ext = explode('.', $file_name);
    $file_ext = strtolower(end($file_ext));
    if (!empty($file_size)) {
        CbK_Avatar::newInstance()->save_image_data($user_id, $file_ext, $file_tmp);
    }
}

osc_add_hook('user_edit_completed', 'cbk_avatar_edit_image');
/*
 * delete image of user
 */

function cbk_avatar_delete_image($user_id) {
    CbK_Avatar::newInstance()->delete_image($user_id);
}

osc_add_hook('after_delete_user', 'cbk_avatar_delete_image');
/*
 * display image in user tabel
 */

function cbk_avatar_admin_tabel_header($table) {
    $table->addColumn('cbk_avatar', __('Avatar', 'cbk_avatar'));
}

osc_add_hook('admin_users_table', 'cbk_avatar_admin_tabel_header');

function cbk_avatar_admin_tabel_content($row, $aRow) {
    $user_id = $aRow['pk_i_id'];
    $image_link = cbk_avatar_image_link_from_id($user_id);
    $image = '<div class="cbk_avatar_image_table"><img src="' . $image_link . '" /></div>';
    $row['cbk_avatar'] = $image;
    return $row;
}

osc_add_filter("users_processing_row", "cbk_avatar_admin_tabel_content");


/*
 * check if avatar is set
 */

function cbk_avatar_is_set($user_id) {
    if (is_numeric($user_id)) {
        $data = CbK_Avatar::newInstance()->user_image($user_id);
        if (isset($data['user_id'])) {
            return true;
        } else {
            return false;
        }
    } else {
        return false;
    }
}

/*
 * add the image in user edit admin form
 */

function cbk_edit_user_form_admin($user) {
    cbk_avatar_deleteBy_user_id($user['pk_i_id'], 'admin');
    ?>
    <script type="text/javascript">
        $(document).ready(function () {
            //add enctype
            $("form").attr("enctype", "multipart/form-data");
        });
    </script>
    <div class="cbk_admin edit_user">
        <h3 class="render-title"><?php _e('Avatar', 'cbk_avatar'); ?></h3>
        <div class="form-row">
            <div class="form-label"><?php _e('Current Avatar', 'cbk_avatar'); ?></div>
            <div class="form-controls">
                <div class="cbk_edit_h">
                    <img src="<?php echo cbk_avatar_image_thumbnail_from_id($user['pk_i_id']); ?>"/>
                    <?php if (cbk_avatar_is_set($user['pk_i_id'])) { ?>
                        <a href="<?php echo osc_admin_base_url(true) . '?page=users&action=edit&id=' . $user['pk_i_id'] . '&cbk_admin_delete_avatar=1'; ?>"><?php _e('Delete', 'cbk_avatar'); ?></a>
                    <?php } ?>
                </div>
            </div>
        </div>
        <div class="form-row">
            <div class="form-label"><?php _e('Set Avatar', 'cbk_avatar'); ?></div>
            <div class="form-controls">
                <?php cbk_avatar_input_field(); ?>
                <?php _e('only', 'cbk_avatar'); ?>: <strong><?php echo cbk_images_extensions_list(); ?></strong>
            </div>
        </div>
    </div>
    <?php
}

if (OC_ADMIN) {
    osc_add_hook('user_form', 'cbk_edit_user_form_admin');
}

/*
 * delete user avatar by user in
 */

function cbk_avatar_deleteBy_user_id($user_id, $location = NULL) {
    if ($location == 'admin') {
        if (osc_is_admin_user_logged_in()) {
            if (Params::getParam('cbk_admin_delete_avatar') == '1') {
                if (is_numeric($user_id)) {
                    if (CbK_Avatar::newInstance()->delete_image($user_id)) {
                        osc_add_flash_ok_message(__('Avatar deleted successfully.', 'cbk_avatar'), 'admin');
                    } else {
                        osc_add_flash_error_message(__('Some error occured when trying to delete the avatar.', 'cbk_avatar'), 'admin');
                    }
                    header("Location:" . osc_admin_base_url(true) . '?page=users');
                }
            }
        }
    } else {
        if (osc_is_web_user_logged_in()) {
            if (Params::getParam('cbk_delete_avatar') == '1') {
                if (is_numeric($user_id)) {
                    if (CbK_Avatar::newInstance()->delete_image($user_id)) {
                        osc_add_flash_ok_message(__('Avatar deleted successfully.', 'cbk_avatar'));
                    } else {
                        osc_add_flash_error_message(__('Some error occured when trying to delete the avatar.', 'cbk_avatar'));
                    }
                    header("Location:" . osc_user_profile_url());
                }
            }
        }
    }
}

/*
 * display the image avatar
 * inlcude this line in theme
 */

function cbk_avatar_display($custom_class = NULL) {
    ?>
    <div class="cbk_avatar_display <?php echo $custom_class; ?>">
        <img src="<?php echo cbk_avatar_thumbnail_link(); ?>" />
    </div>
    <?php
}

/*
 * custom style
 */

if (osc_get_preference('custom_style', 'cbk_avatar') != '') {

    function cbk_avatar_custom_style() {
        $style = trim(osc_get_preference('custom_style', 'cbk_avatar'));
        if (!empty($style)) {
            ?>
            <style type="text/css">
            <?php echo $style; ?>
            </style>
            <?php
        }
    }

    osc_add_hook('footer', 'cbk_avatar_custom_style');
}

/*
 * delete files and folders
 */

function cbk_avatar_delete_folder($path) {
    if (is_dir($path) === true) {
        $files = array_diff(scandir($path), array('.', '..'));

        foreach ($files as $file) {
            cbk_avatar_delete_folder(realpath($path) . '/' . $file);
        }

        return rmdir($path);
    } else if (is_file($path) === true) {
        return unlink($path);
    }

    return false;
}

/*
 * folder size
 */

function cbk_avatar_folderSize($dir) {
    $size = 0;
    foreach (glob(rtrim($dir, '/') . '/*', GLOB_NOSORT) as $each) {
        $size += is_file($each) ? filesize($each) : cbk_avatar_folderSize($each);
    }
    return $size;
}

/*
 * auto embed
 * 
 */

if (osc_get_preference('auto_embed', 'cbk_avatar') == '1') {
    //register page
    osc_add_hook('user_register_form', 'cbk_avatar_include_form');
    //edit user page
    osc_add_hook('user_profile_form', 'cbk_avatar_include_form');
}