<?php

/*
 * Copyright (C) 2017 Puiu Calin
 * This program is a commercial software: is forbidden to use this software without licence, 
 * on multiple installations, and by purchasing from other source than those authorized for the sale of software.
 * Unauthorized copying of this file, via any medium is strictly prohibited
 */

/*
 * save avatar images in other dimensions
 */

function cbk_avatar_other_dimensions_image() {
    if (osc_get_preference('other_dimensions', 'cbk_avatar') == 1) {
        return true;
    } else {
        return false;
    }
}

/*
 * image dimensions
 */

function cbk_avatar_image_dimension_small() {
    $saved_dimension = '50x50';
    if (osc_get_preference('small_dimension', 'cbk_avatar') != '') {
        $saved_dimension = osc_get_preference('small_dimension', 'cbk_avatar');
    }
    $size = explode('x', $saved_dimension);
    return $size;
}

function cbk_avatar_image_dimension_thumb() {
    $saved_dimension = '100x100';
    if (osc_get_preference('thumb_dimension', 'cbk_avatar') != '') {
        $saved_dimension = osc_get_preference('thumb_dimension', 'cbk_avatar');
    }
    $size = explode('x', $saved_dimension);
    return $size;
}

function cbk_avatar_image_dimension_normal() {
    $saved_dimension = '200x200';
    if (osc_get_preference('normal_dimension', 'cbk_avatar') != '') {
        $saved_dimension = osc_get_preference('normal_dimension', 'cbk_avatar');
    }
    $size = explode('x', $saved_dimension);
    return $size;
}

/*
 * image link from user_id
 */

function cbk_avatar_image_path_exists($data, $type) {
    $link = cbk_image_folder_path() . '/' . $data['c_path'] . '/profile' . $data['user_id'];
    if ($type == 'thumbnail') {
        $link = $link . '_thumbnail.' . $data['file_extension'];
    } else {
        $link = $link . '_normal.' . $data['file_extension'];
    }
    if (file_exists($link)) {
        return true;
    } else {
        return false;
    }
}

function cbk_avatar_image_link_from_id($user_id) {
    $data = CbK_Avatar::newInstance()->user_image($user_id);
    $link = cbk_avatar_no_image_link();
    if (!empty($data)) {
        $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '.' . $data['file_extension'];
    }
    return $link;
}

/*
 * image thumbnail from user_id
 */

function cbk_avatar_image_thumbnail_from_id($user_id) {
    $data = CbK_Avatar::newInstance()->user_image($user_id);
    $link = cbk_avatar_no_image_link('thumbnail');
    if (!empty($data)) {
        if (cbk_avatar_image_path_exists($data, 'thumbnail')) {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '_thumbnail.' . $data['file_extension'];
        } else {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '.' . $data['file_extension'];
        }
    }
    return $link;
}

/*
 * image normal from user_id
 */

function cbk_avatar_image_normal_from_id($user_id) {
    $data = CbK_Avatar::newInstance()->user_image($user_id);
    $link = cbk_avatar_no_image_link('normal');
    if (!empty($data)) {
        if (cbk_avatar_image_path_exists($data, 'normal')) {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '_normal.' . $data['file_extension'];
        } else {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '.' . $data['file_extension'];
        }
    }
    return $link;
}

/*
 * image link for front end
 */

function cbk_avatar_image_link() {
    $user_id = osc_item_user_id();
    if (empty($user_id)) {
        $user_id = osc_user_id();
    }
    if (!empty($user_id)) {
        $data = CbK_Avatar::newInstance()->user_image($user_id);
        if (empty($data)) {
            $link = cbk_avatar_no_image_link();
        } else {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '.' . $data['file_extension'];
        }
        return $link;
    } else {
       return cbk_avatar_no_image_link();
    }
}

function cbk_avatar_thumbnail_link() {
    $user_id = osc_item_user_id();
    if (empty($user_id)) {
        $user_id = osc_user_id();
    }
    if (!empty($user_id)) {
        $data = CbK_Avatar::newInstance()->user_image($user_id);
        if (empty($data)) {
            $link = cbk_avatar_no_image_link('thumbnail');
        } else {
            if (cbk_avatar_image_path_exists($data, 'thumbnail')) {
                $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '_thumbnail.' . $data['file_extension'];
            } else {
                $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '.' . $data['file_extension'];
            }
        }
        return $link;
    } else {
       return cbk_avatar_no_image_link('thumbnail'); 
    }
}

function cbk_avatar_normal_link() {
    $user_id = osc_item_user_id();
    if (empty($user_id)) {
        $user_id = osc_user_id();
    }
    if (!empty($user_id)) {
        $data = CbK_Avatar::newInstance()->user_image($user_id);
        if (empty($data)) {
            $link = cbk_avatar_no_image_link('normal');
        } else {
            if (cbk_avatar_image_path_exists($data, 'normal')) {
                $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '_normal.' . $data['file_extension'];
            } else {
                $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/users/' . $data['c_path'] . '/profile' . $user_id . '.' . $data['file_extension'];
            }
        }
        return $link;
    } else {
        return cbk_avatar_no_image_link('normal');
    }
}

/*
 * standard no image link
 */

function cbk_avatar_no_image_link($type = NULL) {
    $curent_image_extension = osc_get_preference('no_image_extension', 'cbk_avatar');
    if (!empty($curent_image_extension)) {
        $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/images/no_image.' . $curent_image_extension;
        if ($type == 'thumbnail') {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/images/no_image_thumbnail.' . $curent_image_extension;
        } elseif ($type == "normal") {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/images/no_image_normal.' . $curent_image_extension;
        }
    } else {
        $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/images/no_images/no_image.png';
        if ($type == 'thumbnail') {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/images/no_images/no_image_thumbnail.png';
        } elseif ($type == "normal") {
            $link = osc_base_url() . 'oc-content/plugins/cbk_avatar/images/no_images/no_image_normal.png';
        }
    }
    return $link;
}

/*
 * image path
 */

function cbk_image_folder_path() {
    return osc_plugin_path('cbk_avatar/users');
}

/*
 * extensions for images
 */

function cbk_images_exensions() {
    $extensions = array('jpg', 'jpeg', 'png', 'gif');
    return $extensions;
}

function cbk_images_extensions_list() {
    $extensions = cbk_images_exensions();
    return implode(',', $extensions);
}

/*
 * image size
 */

function cbk_avatar_size() {
    //if use mb
    /*
      $Mb_value = '1';
      $refer = '1048576';
      $transform_b = $Mb_value * $refer;
      return $transform_b;
     */
    //in kb
    $kb_value = 2048;
    if (osc_get_preference('max_size', 'cbk_avatar') != '') {
        $kb_value = osc_get_preference('max_size', 'cbk_avatar');
    }
    $refer = '1024';
    $transform_b = $kb_value * $refer;
    return $transform_b;
}

//echo cbk_avatar_size();

function cbk_avatar_formatSize($bytes) {
    $types = array('B', 'KB', 'MB', 'GB', 'TB', 'PB');
    for ($i = 0; $bytes >= 1024 && $i < ( count($types) - 1 ); $bytes /= 1024, $i++)
        ;
    return( round($bytes, 2) . " " . $types[$i] );
}

/*
 * user delete avatar link
 */

function cbk_avatar_user_delete_avatar_link() {
    $user_id = osc_user_id();
    if ($user_id) {
        if (osc_rewrite_enabled()) {
            return osc_user_profile_url() . '?cbk_delete_avatar=1';
        } else {
            return osc_user_profile_url() . '&cbk_delete_avatar=1';
        }
    }
}

/*
 * images for admin explication
 */

function cbk_avatar_admin_images($image, $extension) {
    return osc_base_url() . 'oc-content/plugins/cbk_avatar/images/results/' . $image . '.' . $extension;
}

/*
 * get the server max size
 */

function cbk_avatar_get_max_size_server() {
    $max_upload = (int) ( ini_get('upload_max_filesize') );
    $max_post = (int) ( ini_get('post_max_size') );
    $memory_limit = (int) ( ini_get('memory_limit') );
    $maxPHPsize = min($max_upload, $max_post, $memory_limit) * 1024;
    return $maxPHPsize;
}

/*
 * size on install base on server
 */

function cbk_avatar_size_on_install() {
    $server = cbk_avatar_get_max_size_server();
    $value = 1024;
    if ($value > $server) {
        $value = $server;
    }
    return $value;
}

/*
 * author credit
 */

function cbk_avatar_autor_rights() {
    ?>
    <div class="autor_calinbehtuk">
        <span class="p_ro"></span><span>themesCalinbehtuk</span> &#9400; 
            <?php echo date("Y"); ?> 
            <?php _e('All rights reserved', 'cbk_avatar'); ?>
        | <a target="_blank" href="http://theme.calinbehtuk.ro/?page_id=136"><?php _e('Contact', 'cbk_avatar'); ?></a>
    <div class="fb-like" data-href="https://www.facebook.com/Calinbehtuk-themes-1086739291344584/" data-layout="standard" data-action="like" data-show-faces="false" data-share="false"></div>
    </div>
    <div id="fb-root"></div>
    <script>(function (d, s, id) {
            var js, fjs = d.getElementsByTagName(s)[0];
            if (d.getElementById(id))
                return;
            js = d.createElement(s);
            js.id = id;
            js.src = "//connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.5&appId=651333508343077";
            fjs.parentNode.insertBefore(js, fjs);
        }(document, 'script', 'facebook-jssdk'));</script>
    <?php
}