<?php
/*
 * Copyright (C) 2017 Puiu Calin
 * This program is a commercial software: is forbidden to use this software without licence, 
 * on multiple installations, and by purchasing from other source than those authorized for the sale of software.
 * Unauthorized copying of this file, via any medium is strictly prohibited
 */

/*
  Plugin Name: CbK Avatar
  Plugin URI: http://theme.calinbehtuk.ro/
  Description: Set an avatar for users.
  Version: 1.0.0
  Author: Puiu Calin
  Author URI: http://theme.calinbehtuk.ro/
  Plugin update URI: cbk-avatar
  Short Name: cbk-avatar
 */

define('CbKAvatar_Version', '100');
require_once 'include/model.php';
require_once 'include/handler.php';
require_once 'include/helpers.php';

function cbk_avatar_install() {
    CbK_Avatar::newInstance()->install();
}

function cbk_avatar_uninstall() {
    CbK_Avatar::newInstance()->uninstall();
}

function cbk_avatar_admin_menu() {
    osc_add_admin_menu_page(__('CbK Avatar', 'cbk_avatar'), osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/settings.php'), 'cbk_avatar');
}

function cbk_avatar_admin_css() {
    osc_enqueue_style('cbk_avatar_admin_css', osc_base_url() . 'oc-content/plugins/cbk_avatar/css/admin.css');
}

//body calss for plugin admin page
function cbk_avatar_admin_body_class($array) {
    $array[] = 'cbk_avatar_body';
    return $array;
}

function cbk_avatar_admin_title() {
   return  __('Settings CbK Avatar');
}

if (OC_ADMIN && Params::getParam('file') == 'cbk_avatar/admin/settings.php') {
    //body class
    osc_add_filter('admin_body_class', 'cbk_avatar_admin_body_class');
    //title
    osc_add_filter('custom_plugin_title', 'cbk_avatar_admin_title');
}
osc_add_hook('admin_menu_init', 'cbk_avatar_admin_menu');
osc_add_hook('admin_header', 'cbk_avatar_admin_css');
osc_enqueue_style('cbk_avatar', osc_base_url() . 'oc-content/plugins/cbk_avatar/css/style.css');
osc_register_plugin(osc_plugin_path(__FILE__), 'cbk_avatar_install');
osc_add_hook(osc_plugin_path(__FILE__) . "_uninstall", 'cbk_avatar_uninstall');
