<?php
  /*
 * Copyright 2017 osclass-pro.com
 *
 * You shall not distribute this theme and any its files (except third-party libraries) to third parties.
 * Rental, leasing, sale and any other form of distribution are not allowed and are strictly forbidden.
 */

osc_enqueue_script('jquery');
osc_enqueue_script('jquery-ui');
osc_enqueue_script('select');
osc_enqueue_script('owl');
osc_enqueue_script('main');
osc_enqueue_script('date');
osc_enqueue_script('jquery-validate');
?>
<!DOCTYPE html>
<html lang="<?php echo str_replace('_', '-', osc_current_user_locale()); ?>">
    <head>
        <?php osc_current_web_theme_path('head.php'); ?>
        <meta name="robots" content="noindex, nofollow" />
        <meta name="googlebot" content="noindex, nofollow" />
    </head>
    <body>
        <?php osc_current_web_theme_path('header.php'); ?>
		<div class="forcemessages-inline">
    <?php osc_show_flash_message(); ?>
</div>
<div class="col-wrp">
						<div class="col-left">
                        <div class="left-menu">
                            <div class="profile-demo">
                                <img src="<?php echo osc_current_web_theme_url('img/profile.jpg'); ?>" alt="img">
                                <strong class="profile-demo__title"><?php _e('User account manager', 'violet'); ?></strong>
                                <a href="<?php echo osc_user_profile_url(); ?>"><strong><?php echo osc_logged_user_name(); ?></strong></a>
                            </div>
                            <ul>
<?php echo osc_private_user_menu(get_user_menu()); ?>
                            </ul>
                        </div>
                    </div>
<div class="col-main">
                 <h2 class="page-title">
                  <?php _e('Your alerts', 'violet'); ?>
                 </h2>
				 <section class="board-list board-list--ins">
<div class="list-item__inline">
<div class="list">
                                           <?php if(osc_count_alerts() == 0) { ?>
                                               <h3><?php _e('You do not have any alerts yet', 'violet'); ?>.</h3>
                                           <?php } else { ?>
                                           <?php while(osc_has_alerts()) { ?>

                                                                   <div class="">
                                                                       <h4>
                                                                           <?php _e('Alert', 'violet'); ?> | <a onclick="javascript:return confirm('<?php echo osc_esc_js(__('This action can\'t be undone. Are you sure you want to continue?', 'violet')); ?>');" href="<?php echo osc_user_unsubscribe_alert_url(); ?>"><?php _e('Delete this alert', 'violet'); ?></a>
                                                                       </h4>
                                                                   </div>
                                                                   <div class="listings">
                                                                       <?php if(osc_count_items() == 0) { ?>
                                                                           <p class="title__text"><?php _e('No listings have been added yet', 'violet'); ?></p>
                                                                       <?php } else { ?>
                                                                           <?php while(osc_has_items()) { ?>
   <div class="item-list-main">
								 <div class="item-inline">
															<?php if( osc_images_enabled_at_items() ) { ?>
													<?php if( osc_count_item_resources() ) { ?>
									<a href="<?php echo osc_item_url() ; ?>" class="item-inline__img-wrp" style="background-image: url(<?php echo osc_resource_thumbnail_url(); ?>)">
										<?php } else { ?>
									<a href="<?php echo osc_item_url() ; ?>" class="item-inline__img-wrp" style="background-image: url(<?php echo osc_current_web_theme_url('img/no_photo.gif') ; ?>)">
													<?php } ?>
													</a>
												<?php } ?>

 <div class="item-inline__ins">
                                    <div class="item-inline__ins__in discabinet">
                                        <div class="item-inline__desc">
										<?php if( osc_get_preference('item-icon', 'violet') == 'enable') {?>
                                            <a href="<?php echo osc_item_url() ; ?>" class="item-inline__cat">
													<img src="<?php echo osc_current_web_theme_url('img/').violet_category_root(osc_item_category_id()).'.png'; ?>">		
                                            </a>
											<?php } ?>
	<a href="<?php echo osc_item_url() ; ?>" class="item-inline__title"><?php echo osc_highlight(osc_item_title()); ?></a>
                                            <div class="item-inline__text">
                                                <p><?php echo osc_highlight(osc_item_description()); ?></p>
                                            </div>
											<span class="item-inline__place"><i class="place-ico"></i><?php echo osc_item_city() ; ?></span>
											</div>
                                        <div class="item-inline__action">
                                            <strong class="item-inline__price"><?php if( osc_price_enabled_at_items() && osc_item_category_price_enabled(osc_item_category_id()) ) { echo osc_item_formated_price() ; } ?></strong>
                                            <a href="<?php echo osc_item_url() ; ?>" class="btn-pink upcase"><strong><?php _e("read more", 'violet'); ?></strong></a>
											<span class="item-inline__date"><i class="calendar-ico"></i><?php echo osc_format_date(osc_item_pub_date()); ?></span>
                                        </div>
                                    </div>
                                </div>
                            </div>
								</div>
                                                                           <?php } ?>
                                                                       <?php } ?>
                                                                   </div>
                                           <?php } ?>
                                           <?php } ?>
                                                               </div>
                                                           </div>
                                                  </section>
                                       </div>
                                   </div>
                               </div>
                           </div>
                       </div>
                   </div>
                   <!-- content -->
                 </div>
               </div><div style="clear:both"></div>

        <?php osc_current_web_theme_path('footer.php'); ?>
    </body>
</html>